<!--
title: Updating applications
description: This page describes the workflows to update the applications running in the JCR Kubernetes clusters.
published: true
date: 2023-06-04T20:53:49.431Z
tags: kubernetes
editor: ckeditor
dateCreated: 2022-01-11T14:15:32.595Z
-->

<h1>Updating applications</h1>
<p>The workflow to update the following applications will be described:</p>
<ol>
  <li>CTFd</li>
  <li>cert-manager</li>
  <li>doppler-operator</li>
  <li>gitlab runner</li>
  <li>ingress-nginx</li>
  <li>logging stack (Loki, Promtail)</li>
  <li>monitoring stack (Prometheus, Grafana)</li>
  <li>Longhorn</li>
  <li>Renovate</li>
  <li>Wiki.js</li>
</ol>
<h2>CTFd</h2>
<p>In it's current form, updating CTFd images is not ideal. New images are tagged using the ‘latest’ tag. In order to update the image, perform a hard refresh in ArgoCD. In the future, new releases will receive proper tags. Renovate will scan new images and create an automatic merge request whenever there is an image available in the private registry. Whenever a new image becomes available, deploy it in the staging environment first and perform some (automated) tests on it before releasing it in production. More in the <a href="https://gitlab.com/jointcyberrange.nl/ctfd-jcr/-/blob/main/FAQ.md">gitlab repo Developer FAQ</a>.</p>
<h2>Cert-manager</h2>
<p>In it's current form, updating Cert-manager is not ideal. New Cert-manager updates are added as assets in their respective Github releases. Renovate cannot detect a new version automatically. To update Cert-manager, go to the releases page: <a href="https://github.com/jetstack/cert-manager/releases">cert-manager.</a> Look for the latest stable release and compare it with the one defined in the ArgoCD repository. If a new version is available, change the version in the Git repo and deploy it in staging. Change the following file: <strong><u>apps/cert-manager/overlays/staging/kustomization.yaml</u></strong>. You can check if it is working correctly by visiting the ctfd staging website: <a href="https://dev-jointcyberrange.nl/">jcr</a>. If it still has a valid certificate after redeploying Cert-manager, it works as intended. You can now deploy it in production. Change the following file: <strong><u>apps/cert-manager/overlays/production/kustomization.yaml</u></strong>. You can check if it is working correctly by visiting the ctfd demo website: <a href="https://demo.jointcyberrange.nl/">jcr</a>. If it still has a valid certificate after redeploying Cert-manager, it works as intended.</p>
<p><strong>This workflow should be improved in the future.</strong></p>
<h2>Doppler-operator</h2>
<p>In it's current form, updating Doppler-operator is not ideal. New Doppler-operator updates are added as assets in their respective Github releases. Renovate cannot detect a new version automatically. &nbsp;To update Doppler-operator, go to the releases page: <a href="https://github.com/DopplerHQ/kubernetes-operator/releases">Doppler-operator</a>. Look for the latest stable release and compare it with the one defined in the ArgoCD repository. If a new version is available, change the version in the Git repo and deploy it in staging. Change the following file: <strong><u>apps/doppler-operator/overlays/staging/kustomization.yaml</u>. </strong>You can check if it is working correctly by visiting the ctfd staging website: <a href="https://dev-jointcyberrange.nl/">jcr</a>.If you can still login to the website, the website successfully retrieved it's secrets.<strong> </strong>When everything works accordingly, deploy it in production. Change the following file: <strong>apps/doppler-operator/overlays/production/kustomization.yaml. </strong>You can check if it is working correctly by visiting the ctfd demo website: <a href="https://demo.jointcyberrange.nl/">jcr</a>. If you can still login to the website, the website successfully retrieved it's secrets.<strong>&nbsp;</strong></p>
<p><strong>This workflow should be improved in the future.</strong></p>
<h2>Gitlab runner</h2>
<p>In it's current form, updating Gitlab runner is not ideal. New Gitlab runner updates are added to Docker Hub. Renovate cannot detect a new version automatically. To update Gitlab runner, go to the Docker Hub page: <a href="https://hub.docker.com/r/gitlab/gitlab-runner/tags?page=1&amp;name=alpine-v14.6.">Docker Hub</a>. Our build of Gitlab Runner uses the Gitlab Alpine image. Look at the latest release of Alpine 14.x.x and compare it with the one we are running. &nbsp;If a new version is available, change the version in the Git repo and deploy it in staging. You can check if it is working correctly by running a new CI pipeline. If it doesn't fail, the new version is working correctly. As of the time of writing, the Gitlab runner is only deployed in our staging cluster.&nbsp;</p>
<p><strong>This workflow should be improved in the future.</strong></p>
<h2>Ingress-NGINX</h2>
<p>In it's current form, updating Ingress- NGINX is not ideal. New Ingress-NGINX updates are added as Helm charts. We deployed the chart using Helm's template functionality. Renovate cannot detect a new version automatically. To update Ingress-nginx, go to the releases page: <a href="https://github.com/kubernetes/ingress-nginx/releases">Ingress-NGINX</a>. As of the time of writing, Helm charts are not officially supported by ArgoCD-autopilot. We used helm template to deploy this application and we must also use it to update the application. If a newer release is available, update the application in staging by running the following commands in the argocd-kustomize repo:&nbsp;</p>
<pre><code class="language-plaintext">cd apps/ingress-nginx/
helm repo add ingress-nginx https://kubernetes.github.io/ingress-nginx
helm repo update
helm template ingress-nginx --namespace ingress-nginx ingress-nginx/ingress-nginx -f ./values.yaml &gt; overlays/staging/nginx.yaml</code></pre>
<p>Updating Nginx is gonna take a while. Follow it's progress on the ArgoCD UI. When it's done, check the staging jcr website: <a href="https://dev-jointcyberrange.nl/">jcr</a>. If it's still reachable, the update went fine. You can now deploy it in production with the following commands:</p>
<pre><code class="language-plaintext">helm template ingress-nginx --namespace ingress-nginx ingress-nginx/ingress-nginx -f ./values.yaml &gt; overlays/production/nginx.yaml</code></pre>
<p>Updating Nginx is gonna take a while. Follow it's progress on the ArgoCD UI. When it's done, check the demo jcr website: <a href="https://demo.jointcyberrange.nl/">jcr</a>. If it's still reachable, the update went fine.&nbsp;</p>
<h2>Logging stack (Loki, Promtail)</h2>
<p>In it's current form, updating the logging stack works well. Renovate detects new versions released on Github and creates an automated merge request. Merging the merge request updates the application in the staging cluster. If the update is successful, you must update the production environment(s) manually. The manual updating of production ensures the update goes correctly and doesn't break running environments.</p>
<p><strong>Updating Loki to version 2.4 leads to errors, this needs to be fixed in the future.</strong> Updating Promtail goes fine.&nbsp;</p>
<h2>Monitoring stack (Prometheus, Grafana)</h2>
<p>In it's current form, updating the monitoring stack works well. Renovate detects new versions released on Docker hub and creates an automated merge request. Merging the merge request updates the application in the staging cluster. If the update is successful, you must update the production environment(s) manually. The manual updating of production ensures the update goes correctly and doesn't break running environments.</p>
<p><strong>Updating prometheus-operator to the latest version leads to problems, this needs to be resolved in the future.</strong></p>
<h2>Longhorn</h2>
<p>In it's current form, updating Longhorn runner is not ideal. New Longhorn updates are added to Github releases. Renovate cannot detect a new version automatically. To update Longhorn, go to the releases page: <a href="https://github.com/longhorn/longhorn/releases">Longhorn</a>. Look for the latest stable release and compare it with the one defined in the ArgoCD repository. If a new version is available, change the version in the Git repo and deploy it in staging. Change the following file: <strong><u>apps/longhorn/overlays/staging/kustomization.yaml.</u></strong> You can check if it is working correctly by checking if the staging jcr application is still working: <a href="https://dev-jointcyberrange.nl/">jcr</a>. When everything works accordingly, deploy it in production. Change the following file: <strong><u>apps/longhorn/overlays/production/kustomization.yaml</u></strong>. Updating Longhorn is not critical, since it isn't exposed as a web service.</p>
<h2>Renovate</h2>
<p>In it's current form, updating the Renovate works well. Renovate detects new versions released on Docker hub and creates an automated merge request.</p>
<p>Example merge request:</p>
<figure class="image"><img src="Assets/merge_request_example.png"></figure>
<p>In order to merge, just press merge and the Renovate branch will merge with main. ArgoCD will update the Kubernetes cluster with the new updated version of the application.</p>
<h2>Wiki.js</h2>
<p>In it's current form, updating the Wiki.js works well. Renovate detects new versions released on Docker hub and creates an automated merge request. Merging the merge request updates the application in the staging cluster. If the update is successful, you must update the production environment(s) manually. The manual updating of production ensures the update goes correctly and doesn't break running environments.</p>
<h2>Future improvements</h2>
<p>Some workflows should be improved in the future. Here's a list of what should be done in the future to improve the update workflow of the previous applications:</p>
<ul>
  <li>CTFd needs a proper build workflow (CI) which utilizes image tags. If that's implemented, Renovate should automate the update process.</li>
  <li>Renovate cannot automatically update cert-manager. Look for a way to do this later.</li>
  <li>Renovate cannot automatically update Doppler-operator. Look for a way to do this later.</li>
  <li>Renovate cannot automatically update Gitlab-runner. Look for a way to do this later.</li>
  <li>Ingress-NGINX is deployed via a Helm chart. There´s no native support for this in ArgoCD autopilot. Keep on the lookout for this in the future.</li>
</ul>
